function normValue = h1_semi_norm( grid, basis, uh, grad_u, nQuad )
% This function computes the H1 semi norm of uh-u.
%
%   Input:
%       grid    Discrete grid.
%       basis   Basis living on the grid.
%       uh      Vector representation of some finite element function
%               w.r.t. the given basis.
%       grad_u  Function handle for gradient of some continuous function.
%               The handle needs to support evaluations of the kind u(x)
%               where x is a matrix [x1, ..., xn] in R^(dim x n) of points.
%       nQuad   Order of applied quadrature rule minus (order of the finite
%               element functions minus one).
%
%   Output:
%       normValue   Value of the resulting norm.
%

    normValue   = 0;
    dim         = size(grid.nodes,1);

    % Iterate over all elements.
    for elementIndex=1:size(grid.elements,2)
        
        % DO MAGIC HERE

    end

    % Take the square root to get the actual norm.
    normValue   = sqrt(normValue);
end

